// ****************************************************************************
// This program computes the greatest common divisor of two given numbers:
// Based on the observation that gcd(a,b) = gcd(b,a mod b) holds for b!=0, 
// one iteratively reduces the computation until b==0 holds.
// ****************************************************************************

        movu R1,124     // R1 := a
        movu R2,84      // R2 := b
  loop: movr R3,R2      // R3 := R2;
        divu R2,R1,R2   // R2 := R1 / R2;
        ovf R2          // R2 := R1 % R2;
        movr R1,R3      // R1 := R3;
        bnz R2,R0,loop  // if R2!=0 goto loop
   end: nop             // otherwise, R1 holds the gcd
