// ****************************************************************************
// This program implements Heron's iterative procedure to compute square roots.
// To compute the square root of a>0, the iteration starts with x{0} := a and
// computes x{n+1} := 0.5 * (x{n} + a/x{n}) until the sequence of numbers x{n}
// is no longer decreasing. Then, an integer approximation of sqrt(a) is found. 
// ****************************************************************************

        movu R1,120     // R1 := a
        movr R2,R1      // x{n} is initially a
  loop: movr R3,R2      // store x{n}     
        divu R2,R1,R3   // R3 := a/x{n};
        addu R2,R3,R2   // R3 := x{n} + a/x{n};
        diviu R2,R2,2   // R3 := 0.5 *  x{n} + a/x{n});
        slt R4,R2,R3    // R4 := x{n+1}<x{n};
        bnz R4,R0,loop  // if R4!=0, re-iterate loop
   end: nop             // otherwise, R2 holds the square root of a
