// ****************************************************************************
// This program checks whether a given number is a prime number. The program
// is rather inefficient since it checks whether all odd numbers less than
// the square root of the given number are divisors.
// ****************************************************************************

        movu R1,113         // put number to be checked in R1
        movu R2,2           // test whether it is an even number
        divu R3,R1,R2       // R3 := R1 / 2
        ovf R3              // R3 := R1 % 2
        seq R4,R0,R3        // R4 := 0==R3
        bez R4,R0,tstodd    // if R1%2!=0 then goto tstodd 
        jmp R0,noprim       // otherwise, goto noprim 
tstodd: movu R2,3           // R3 := 3
  loop: divu R3,R1,R2       // R3 := R1 / R2
        ovf R3              // R3 := R1 % R2
        seq R4,R0,R3        // R4 := R3==0
        bnz R4,R0,noprim    // if R1%R2==0 goto noprim
        addiu R2,R2,2       // R2 := R2 + 2
        mulu R3,R2,R2       // R3 := R2 * R2
        sleu R4,R3,R1       // R4 := R3<=R1
        bnz R4,R0,loop      // if R3<=R1 goto loop
  prim: movu R4,1           // otherwise all potential divisors are tested
        j end               // jump to end
noprim: movu R4,0           // divisor has been found in R2
   end: nop             

// after termination, R4==1 means prime number, and
// R4==0 means not primal, and R2 is a divisor
