// ****************************************************************************
// This program computes the list of the first prime numbers using the sieve
// of Eratosthenes.
// ****************************************************************************

#DataWidth   8
#MemSize    20
#NumOfLines  4
#LineSize    2
#SetAssoc    2
#MissPenalty 0
#cpuName     ScalarBehav
#memName     CachedMemory

// first, we generate an array holding integers 2..sizeOfArray+1
        movu R1,0           // address of first array element mem[0]
        movu R2,20          // address of last array element mem[n]
        movu R3,2           // next number to be written
        movu R4,0           // will be used as loop variable
    l1: st R3,R4,0          // mem[i] := R3
        addi R3,R3,1        // R3 := R3 + 1
        addi R4,R4,1        // R4 := R4 + 1
        seq R5,R4,R2        // R5 := R4==R2
        bez R5,R0,l1        // if R4!=R2 goto l1
// from here, sieving takes place
        movu R3,0           // R3 stores the next index to use for sieving
    l4: movr R4,R3          // R4 stores the index of next array element to be considered
        ld R5,R4,0          // load mem[R4] to R5
    l2: addu R4,R4,R5       // increase R4 by R5
        slt R6,R4,R2        // check whether we are still in the array bound
        bez R6,R0,l3        // if not, proceed with l3
        st R0,R4,0          // otherwise overwrite mem[R4] := 0
        j l2                // goto l2
    l3: addi R3,R3,1        // here, we seek the next element for sieving 
        slt R6,R3,R2        // check whether R3+1 is still in the array bound
        bez R6,R0,end       // if not, all prime elements have been used for sieving -> terminate
        ld R5,R3,0          // otherwise, load R5 := mem[R3]
        bez R5,R0,l3        // if mem[R3]==0, then next array element has to be checked, thus, goto l3
        j l4                // otherwise, we can sieve with mem[R3], thus goto l4
   end: sync                // write back cache content
        nop     